var gc = gc || {};

function init() {

  function qaWatchdog_Interface(packetParser, sendPacket) {
    OCFBaseEx.apply(this, arguments);
    this.handlers = [];
  };

  qaWatchdog_Interface.prototype = Object.create(OCFBaseEx.prototype);
  qaWatchdog_Interface.prototype.constructor = qaWatchdog_Interface;
  OCFBaseEx.prototype.add_interface('qawatchdog', qaWatchdog_Interface);

  qaWatchdog_Interface.prototype.ensureConfigured = function (config_seq) {}

  var createWatchdogPacket = function (unit, params) {
    var packet = [
      [unit, params.questionAddress, params.answerAddress, params
        .i2cAddress
      ]
    ];
    packet = packet.concat([
      [params.i2c, params.spiWatchdogPage, params.answerCountRegister,
        params.maskForAnswerCountRegister
      ]
    ]);
    packet = packet.concat([
      [params.enable, params.spiMode, params.wrongAnswer, 0]
    ]);
    packet = packet.concat([OCFBase.prototype.value_to_bytes.call(this, params
      .delayQuestion, 32, 'little')]);
    packet = packet.concat([OCFBase.prototype.value_to_bytes.call(this, params
      .delayAnswer3, 32, 'little')]);
    packet = packet.concat([OCFBase.prototype.value_to_bytes.call(this, params
      .delayAnswer2, 32, 'little')]);
    packet = packet.concat([OCFBase.prototype.value_to_bytes.call(this, params
      .delayAnswer1, 32, 'little')]);
    packet = packet.concat([OCFBase.prototype.value_to_bytes.call(this, params
      .delayAnswer0, 32, 'little')]);
    return packet;
  }

  var Watchdog_Interface = 0x1A;
  var cmd_QAWatchdog_Enable = 0x00;
  var cmd_QAWatchdog_Config = 0x01;
  var cmd_QAWatchdog_ExecuteStep = 0x02;

  qaWatchdog_Interface.prototype.get_interface_type = function () {
    return Watchdog_Interface;
  }

  /**
   * Initialize symbols for device
   *
   * @param settings - The interface settings defined in the sys                                           tem.json
   * @param registerModel - The register model
   */
  qaWatchdog_Interface.prototype.initSymbolsForDevice = function (settings,
    registerModel) {
    OCFBaseEx.prototype.initSymbolsForDevice.apply(this, arguments);
  };

  qaWatchdog_Interface.prototype.QAWatchdog_Config = function (unit, params) {
    var watchdogPacket = createWatchdogPacket(unit, params)
    // qaWatchdog_Interface.sendPacket(watchdogPacket);
    return this.h2c_command(Watchdog_Interface, unit, cmd_QAWatchdog_Config,
      watchdogPacket);
  }

  qaWatchdog_Interface.prototype.QAWatchdog_Enable = function (unit, params) {
    var watchdogPacket = [];
    watchdogPacket = watchdogPacket.concat(OCFBase.prototype.value_to_bytes
      .call(this, unit));
    watchdogPacket = watchdogPacket.concat(OCFBase.prototype.value_to_bytes
      .call(this, params.enable));
    return this.h2c_command(Watchdog_Interface, unit, cmd_QAWatchdog_Enable,
      watchdogPacket);
  }

  qaWatchdog_Interface.prototype.QAWatchdog_ExecuteStep = function (unit) {
    return this.h2c_command(Watchdog_Interface, unit,
      cmd_QAWatchdog_ExecuteStep, []);
  }
}

if (gc.databind.AEVMCodec) {
  init();
} else {
  document.addEventListener('DOMContentLoaded', init);
}